Program SteganoCoder_String;
 Type
 { BitMap fejlc }
  TBitMapHeader = Record
                   bfType: Word;
                   bfSize: LongInt;
                   bfReserved1, bfReserved2: Word;
                   bfOffBits, biSize, biWidth, biHeight: LongInt;
                   biPlanes, biBitCount: Word;
                   biCompression, biSizeImage, biXPelsPerMeter: LongInt;
                   biYPelsPerMeter, biClrUsed, biClrImportant: LongInt;
                  End;
 { A BitMap palettjnak egy eleme (kk, zld, piros s tltszsg sszetev) }
  TPaletteItem = Record
                  Blue, Green, Red, Alpha: Byte;
                 End;
 { A 256 szn paletta }
  TPalette = Array[0..255] of TPaletteItem;
 { BMP }
  TBitMap = Record
             Header: TBitMapHeader;
             Palette: TPalette;
            End;
 Var
  BM: TBitMap;
  InFile: File;
  InPath: String[80];
  MainKey, Choice: Char;
  W: Word;
  X: Word;

  Message, A, B: String;

  Line: Array[0..255] of Byte;

 Function ReadKey: Word;
  Var
   Key: Word;
  Begin
   Asm
    mov   ax, $10
    int   $16
    mov   Key, ax
   End;
   ReadKey:=Key;
  End;

 Procedure Quit(ErrCode: Byte);
  Begin
   WriteLn;
   Case ErrCode of
    0: WriteLn('$ Read I/O error!');
    1: WriteLn('$ Write I/O error!');
    2: WriteLn('$ Incorrect BitMap!');
    Else
     WriteLn('$ Unknown error!');
   End;
   Halt;
  End;

Begin
 WriteLn('$ BitMap line remover');

 Write('$ [C]ode or [D]ecode? ');
 Choice:='d';
 Repeat
  MainKey:=Char(ReadKey);
 Until MainKey in ['D','C','d','c'];
 Write(MainKey);
 Choice:=UpCase(MainKey);

 WriteLn(#13#10'$ BitMap Path:');
 ReadLn(InPath);

 {$I-}
 WriteLn('$ Loading...');
 Assign(InFile, InPath);
 FileMode:=$02;
 Reset(InFile,1);
 If IOResult <> 0 then
  Quit(0);
 BlockRead(InFile, BM.Header, SizeOf(BM.Header));
 If IOResult <> 0 then
  Quit(0);
 If (BM.Header.biBitCount <> 8) or (BM.Header.bfType <> $4d42) then
  Quit(2);
 BlockRead(InFile, BM.Palette, SizeOf(TPalette));
 If IOResult <> 0 then
  Quit(0);

 {
 Mretek :-)

 Write('$ Width: ');
 WriteLn(BM.Header.biWidth);
 Write('$ Height: ');
 WriteLn(BM.Header.biHeight);
 Write('$ Image Size: ');
 WriteLn(BM.Header.biSizeImage);
 Write('$ Header Size: ');
 WriteLn(SizeOf(BM.Header));
 Write('$ Palette Size: ');
 WriteLn(SizeOf(BM.Palette));
 Write('$ File Size: ');
 WriteLn(BM.Header.bfSize);
 Quit(0);
 }

 If Choice = 'C' then
  Begin
   WriteLn('$ Coding Message:');
   A := 'e1d0922e8f77c6ca085396b40dcf2180625738e3fe0b348e45fb77a92b25e7ba';
   B := '52b210c5b10e02df50a059769f3c58b907a3d667dc3d9aa37b5d31a425958b30';
   Message := Concat(A, B);
   WriteLn(Message);

   { Kdoljuk a fels sorba az zenetet }
   X := 0;
   For W:=0 to 255 Do
    Begin
     Line[W] := Byte(Message[W]) xor X;
     X := 3*X + 3 mod 255;
    End;

   { Nyomok trlse a fejlcbl }
   BM.Header.bfSize := BM.Header.bfSize;
   BM.Header.biHeight := BM.Header.biHeight - 1;

   Seek(InFile,BM.Header.bfSize);
   BlockWrite(InFile, Line, SizeOf(Line));

   Seek(InFile,0);
   BlockWrite(InFile, BM.Header, SizeOf(BM.Header));

   If IOResult <> 0 then
    Quit(1);
  End

  Else
   Begin
    Seek(InFile,BM.Header.bfSize);
    BlockRead(InFile, Line, SizeOf(Line));

    X := 0;
    For W:=0 to 255 Do
     Begin
      Message[W] := Char(Line[W] xor X);
      X := 3*X + 3 mod 255;
     End;

    WriteLn('$ Message:');
    WriteLn(Message);
   End;

 WriteLn('$ Bye!');
 Close(InFile);
 {$I+}
End.