Program SteganoCoder_String;
 Type
 { BitMap fejlc }
  TBitMapHeader = Record
                   bfType: Word;
                   bfSize: LongInt;
                   bfReserved1, bfReserved2: Word;
                   bfOffBits, biSize, biWidth, biHeight: LongInt;
                   biPlanes, biBitCount: Word;
                   biCompression, biSizeImage, biXPelsPerMeter: LongInt;
                   biYPelsPerMeter, biClrUsed, biClrImportant: LongInt;
                  End;
 { A BitMap palettjnak egy eleme (kk, zld, piros s tltszsg sszetev) }
  TPaletteItem = Record
                  Blue, Green, Red, Alpha: Byte;
                 End;
 { A 256 szn paletta }
  TPalette = Array[0..255] of TPaletteItem;
 { BMP }
  TBitMap = Record
             Header: TBitMapHeader;
             Palette: TPalette;
            End;
 Var
  BM: TBitMap;
  InFile: File;
  InPath: String[80];
  MainKey, Choice: Char;
  W, X: Word;

  Message, A, B: String;

 Function ReadKey: Word;
  Var
   Key: Word;
  Begin
   Asm
    mov   ax, $10
    int   $16
    mov   Key, ax
   End;
   ReadKey:=Key;
  End;

 Procedure Quit(ErrCode: Byte);
  Begin
   WriteLn;
   Case ErrCode of
    0: WriteLn('$ Read I/O error!');
    1: WriteLn('$ Write I/O error!');
    2: WriteLn('$ Incorrect BitMap!');
    Else
     WriteLn('$ Unknown error!');
   End;
   Halt;
  End;

Begin
 WriteLn('$ Steganography Message Coder/Decoder for 256 Coloured Windows BitMaps');

 Write('$ [C]ode or [D]ecode? ');
 Choice:='d';
 Repeat
  MainKey:=Char(ReadKey);
 Until MainKey in ['D','C','d','c'];
 Write(MainKey);
 Choice:=UpCase(MainKey);

 WriteLn(#13#10'$ BitMap Path:');
 ReadLn(InPath);

 {$I-}
 WriteLn('$ Loading...');
 Assign(InFile, InPath);
 FileMode:=$02;
 Reset(InFile,1);
 If IOResult <> 0 then
  Quit(0);
 BlockRead(InFile, BM.Header, SizeOf(BM.Header));
 If IOResult <> 0 then
  Quit(0);
 If (BM.Header.biBitCount <> 8) or (BM.Header.bfType <> $4d42) then
  Quit(2);
 BlockRead(InFile, BM.Palette, SizeOf(TPalette));
 If IOResult <> 0 then
  Quit(0);

 If Choice = 'C' then
  Begin
   WriteLn('$ Coded Message:');
   A := 'b1c4b2fc88d2c709b901118e1cba79844ff2beca3f1b0a59f090fef4be3f6fc4';
   B := '0a3094bd92e97c903ffaf160d0bcd3089bc7c25e2b0f5c09b05129f124971723';
   Message := Concat(A, B);
   WriteLn(Message);

   X := 0;
   For W:=0 to 255 Do
    Begin
     BM.Palette[W].Alpha := Byte(Message[W]) xor X;
     X := 3*X + 3 mod 255;
    End;

   Seek(InFile,FilePos(InFile)-SizeOf(TPalette));
   BlockWrite(InFile, BM.Palette, SizeOf(TPalette));

   If IOResult <> 0 then
    Quit(1);
  End
  Else
   Begin
    X := 0;
    For W:=0 to 255 Do
     Begin
      Message[W]:=Char(BM.Palette[W].Alpha xor X);
      X := 3*X + 3 mod 255;
     End;

    WriteLn('$ Message:');
    WriteLn(Message);
   End;

 WriteLn('$ Bye!');
 Close(InFile);
 {$I+}
End.