package ecriptiondecriptioninjpeg;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.io.FileOutputStream;
import javax.xml.soap.Text;

/**
 *
 * @author Nagy Kristóf
 */
public class JPEG_Processer {

    public JPEG_Processer() {
    }
    private FileInputStream file;
    public Boolean isValidJPEG;
    public Boolean isExistsEOF;
    private int FFD8_Start_mark;
    private int FFE0_JFIF_marker;
    private int FFD9_End_Of_File_mark;
    private int fileEndPosition;
    private FileOutputStream outputJpeg;
    private File inputFileJpeg;
    private File ouputFileJpeg;
    private long inputJpegSizeInByte;
    private long outputJpegSizeInByte;

    public void setJpegPicture(File inputFile) throws Exception {
        this.inputFileJpeg = inputFile;
        this.file = new FileInputStream(inputFile);
        int mark;
        int s;
        int i;
        int position = 0;
        inputJpegSizeInByte = inputFile.length();
        FFD8_Start_mark = -1;
        FFD9_End_Of_File_mark = -1;
        FFE0_JFIF_marker = -1;

        try {
            //The first 2 bytes checking.
            i = 0;
            mark = 0;
            while ((i < 2) && ((s = file.read()) != -1)) {
                mark = (mark << (i * 8)) | s;
                i++;
                position++;
            }
            //FFD8 mark value is 65496
            if (mark == 65496) {
                FFD8_Start_mark = position -1 ;
            } 
            //Read JFIF marker
            i = 0;
            mark = 0;
            while ((i < 2) && ((s = file.read()) != -1)) {
                mark = (mark << (i * 8)) | s;
                i++;
                position++;
            }
            //FFE0 value is 65504
            if (mark == 65504) {
                FFE0_JFIF_marker = position -1 ;
            } 

            //Search the end of the file, the end mark
            //in hexa we search FFD9 in decimal: 65497
            //in two byte: 255 (FF) & 233 (D9)
            i = 0;
            mark = 0;
            boolean hit = false;
            int val = 0;
            while (((s = file.read()) != -1)) {
                position++;
                if ((s == 255) && (i == 0)) {
                    i++;
                } else if ((s == 217) && (i == 1)) {
                    val = position;
                    s = file.read();
                    if (s == -1) {
                        hit = true;
                    } else {
                        position++;
                        hit = true;
                        if (s != 255) {
                            i = 0;
                        }
                    }
                } else {
                    i = 0;
                }

            }

            //If exists End of JPEG
            if (hit) {
                position = val;
                isExistsEOF = true;
                FFD9_End_Of_File_mark = position -1 ;
            } else {
                isExistsEOF = false;
            }

            if ((FFD8_Start_mark != -1) && (FFE0_JFIF_marker != -1) && (FFD9_End_Of_File_mark != -1)) {
                isValidJPEG = true;
            } else {
                isValidJPEG = false;
            }

            if (position != 0) {
                fileEndPosition = position;
            }

        } catch (Exception e) {
            throw new Exception("Error during process the file");
        }
    }

    public int getFFD8_Start_mark() throws Exception {
        if (file != null) {
            return FFD8_Start_mark;
        } else {
            throw new Exception("First load a picture!");
        }

    }

    public int getFFE0_JFIF_marker() throws Exception {
        if (file != null) {
            return FFE0_JFIF_marker;
        } else {
            throw new Exception("First load a picture!");
        }
    }

    public int getFFD9_End_Of_File_mark() throws Exception {
        if (file != null) {
            if (isValidJPEG) {
                return FFD9_End_Of_File_mark;
            } else {
                return 0;
            }
        } else {
            throw new Exception("First load a picture!");
        }

    }

    public int getFileEndPosition() throws Exception {
        if (file != null) {
            if (isExistsEOF) {
                return fileEndPosition;
            } else {
                throw new Exception("This is not a valid JPEG with 0 byte length.");
            }
        } else {
            throw new Exception("First load a picture!");
        }
    }

    public void AddTextToJpeg(String text, File outputFile) throws Exception {
        if (isValidJPEG) {
        try {
            outputJpeg = new FileOutputStream(outputFile);
            file = new FileInputStream(inputFileJpeg);
            int s;
            while ((s = file.read()) != -1) {
                outputJpeg.write(s);
            }
            
            byte byteText[] = text.getBytes();
            byte x = 0;
            for(int i = 0; i < byteText.length; i++)
            {
                outputJpeg.write(byteText[i] ^ x);
                x = (byte) ((x + 1) % 255);
            }
            outputJpegSizeInByte = outputFile.length();
            
            outputJpeg.flush();
            outputJpeg.close();

        } catch (Exception e) {
            throw new Exception(e.getMessage());
        }
        }
        else {
            throw new Exception("First load a valid lpeg picture!");
        }
    }

    public long getInputJpegSizeInByte() {
        return inputJpegSizeInByte;
    }

    public long getOutputJpegSizeInByte() {
        return outputJpegSizeInByte;
    }
    
    public String getTextFromOpenedJpeg() throws Exception{
        if (isValidJPEG) {
            file = new FileInputStream(inputFileJpeg);
            int s;
            int pos = 0;
            while ((fileEndPosition != pos) && ((s = file.read()) != -1)) {
                pos++;
            }
            Long l = inputFileJpeg.length();
            byte byteText[] = new byte[l.intValue() - pos];
            file.read(byteText);

            String text = new String();
            byte b[] = new byte[byteText.length];
            byte x = 0;
            for(int i = 0; i < byteText.length; i++)
            {
                b[i] = (byte) (byteText[i] ^ x);
                x = (byte) ((x + 1) % 255);
            }
            text = new String(b);
            return text.toString();
        }
        else {
            throw new Exception("First load a valid jpeg picture!");
        }
    }
    
    public void AddTextfileToJpeg(File addingInputFile, File outputFile) throws Exception{
        if (isValidJPEG) {
        try {
            outputJpeg = new FileOutputStream(outputFile);
            FileInputStream inputTextfile = new FileInputStream(addingInputFile);
            file = new FileInputStream(inputFileJpeg);
            int s;
            while ((s = file.read()) != -1) {
                outputJpeg.write(s);
            }

            while ((s = inputTextfile.read()) != -1) {
                outputJpeg.write(s);
            }
            
            outputJpegSizeInByte = outputFile.length();
            
            outputJpeg.flush();
            outputJpeg.close();

        } catch (Exception e) {
            throw new Exception(e.getMessage());
        }
        }
        else {
            throw new Exception("First load a valid jpeg picture!");
        }
    }
}
