
public class HTML_StateMachine
{
	// llapotok
	public static final int STATE_TEXT = 0;
	public static final int STATE_SIMPLEQ = 1;
	public static final int STATE_DOUBLEQ = 2;
	public static final int STATE_TAG = 3;
	public static final int STATE_TAGSPEC = 4;
	
	public static final String validchars = "abcdefghijklmnopqrstuvwxyz";
	
	// Bels llapot
	private int state;
	private byte output;
	
	public HTML_StateMachine()
	{
		state = STATE_TEXT;
	}
	
	public void reset()
	{
		state = STATE_TEXT;
	}

	public void input(byte b)
	{
		// jsor nem szmt
		if(b == '\n')
		{
			return;
		}

		// Minden ms
		switch(this.state)
		{
			case STATE_TEXT:
				if(b == '<')
					setState(STATE_TAG, (byte) 0);
				else
					setState(STATE_TEXT, (byte) 0);
			break;
			case STATE_SIMPLEQ:
				if(b == '\'')
					setState(STATE_TAG, (byte) 0);
				else
					setState(STATE_SIMPLEQ, (byte) 0);
			break;
			case STATE_DOUBLEQ:
				if(b == '"')
					setState(STATE_TAG, (byte) 0);
				else
					setState(STATE_DOUBLEQ, (byte) 0);
			break;
			case STATE_TAG:
				if(b == '\'')
					setState(STATE_SIMPLEQ, (byte) 0);
				else if(b == '"')
					setState(STATE_DOUBLEQ, (byte) 0);
				else if(b == ' ' || b == '\t' || b == '/' || b == '=' || b == '-')
					setState(STATE_TAGSPEC, (byte) 0);
				else if(b == '>')
					setState(STATE_TEXT, (byte) 0);
				else
				{
					if(validchars.indexOf(Character.toLowerCase((char) b)) != -1)
						setState(STATE_TAG, b);
					else
						setState(STATE_TAG, (byte) 0);
				}
			break;
			case STATE_TAGSPEC:
				if(b != ' ' || b != '\t' || b != '/' || b != '=' || b != '-')
				{
					setState(STATE_TAG, (byte) 0);
					input(b);
				}
				else
					setState(STATE_TAGSPEC, (byte) 0);
			break;
			default:
				System.out.println("rtelmezhetetlen llapot.");
			break;
		}
	}
	
	public void setState(int state, byte output)
	{
		this.state = state;
		this.output = output;
	}
	
	public int getState()
	{
		return this.state;
	}
	
	public byte getOutput()
	{
		return this.output;
	}
}
