import java.io.FileOutputStream;


public class BMP_LSB_Stegano
{
	public static final String hexchars = "0123456789abcdef";
	
	private BitMapHeader header;

	public BMP_LSB_Stegano()
	{
		header = new BitMapHeader();
	}
	
	public void code(String in, String out, String code)
	{
		byte[] hdr;
		byte[] line;
		
		try
        {
	        SmartFileInputStream fi = new SmartFileInputStream(in);
	        FileOutputStream fo;
	        
	        header.loadFromStream(fi);
	        fi.close();
	        
	        fi = new SmartFileInputStream(in);
	        fo = new FileOutputStream(out);
	        
	        
	        hdr = new byte[54];
	        line = new byte[(int) header.getBiWidth() * 4];
	        fi.read(hdr);
	        fo.write(hdr);

	        /*
	         * Sorok visszafel, BGRA pixelek (no comment)
	         * */
	        int msgctr = 0;
	        while(fi.read(line) != -1)
	        {
	        	for(int i = 0; i < line.length-3; i += 4)
	        	{
        			byte b = (byte)Math.round(Math.random()); // Kb. ugyanannyi 0 s 1-t generl, teht j
        			
        			// Trljk az uccs bitet
        			line[i+2] >>= 1;
        			line[i+2] <<= 1;
        			
        			// Na ekkor rejtnk
        			if(b == 1 && msgctr < code.length())
        			{
        				line[i+2] = (byte) (line[i+2] | 0x01);
       					line[i+3] = (byte) code.charAt(msgctr);
        				msgctr++;
        			}
        			// Dummy byte :-)
        			else
        			{
        				line[i+3] = (byte) hexchars.charAt((int) Math.floor(Math.random()*16));
        			}
	        	}
	        	fo.write(line);
	        }
	        
            fi.close();
            fo.close();
	        
        } catch (Exception e)
        {
	        System.out.println("Fjl olvassi vagy rsi hiba, hopp!");
	        e.printStackTrace();
        }
	}
	
	public String decode(String in)
	{
		byte[] hdr;
		byte[] line;
		StringBuffer code = new StringBuffer();
		
		try
        {
	        SmartFileInputStream fi = new SmartFileInputStream(in);
	        header.loadFromStream(fi);
	        fi.close();
	        fi = new SmartFileInputStream(in);

	        hdr = new byte[54];
	        line = new byte[(int) header.getBiWidth() * 4];
	        fi.read(hdr);

	        /*
	         * Sorok visszafel, BGRA pixelek (no comment)
	         * */
	        while(fi.read(line) != -1)
	        {
	        	for(int i = 0; i < line.length-3; i += 4)
	        	{
        			// Kiolvassuk
        			if((line[i+2] & 0x01) == 0x01)
        			{
        				code.append((char) line[i+3]);
        			}
	        	}
	        }
	        
            fi.close();
        } catch (Exception e)
        {
	        System.out.println("Fjl olvassi vagy rsi hiba, hopp!");
	        e.printStackTrace();
        }
        
        return new String(code);
	}
	
	public static byte[] stringToCodedByteArray(String s)
	{
		byte[] b = new byte[s.length()];
		byte k = 0;

		for(int i = 0; i < s.length(); i++)
		{
			b[i] = (byte) (((byte) s.charAt(i)) ^ k);
			k = (byte) ((3*k + 3) % 255);
		}
		
		return b;
	}
	
	public static String codedByteArrayToString(byte[] b)
	{
		byte[] ba = new byte[b.length];
		byte k = 0;
		
		for(int i = 0; i < b.length; i++)
		{
			ba[i] = (byte) (b[i] ^ k);
			k = (byte) ((3*k + 3) % 255);
		}
		
		return new String(ba);
	}
	
	/**
	 * Main
	 */
	public static void main(String[] args)
	{
		System.out.println(">> BMP LSB Stegano Coder");
		BMP_LSB_Stegano bmpstg = new BMP_LSB_Stegano();
		if(args.length == 2 && args[0].equals("-d"))
			System.out.println(bmpstg.decode(args[1]));
		else if(args.length == 4 && args[1].equals("-c"))
			bmpstg.code(args[1], args[2], args[3]);
		else
			System.out.println("\tjava BMP_LSB_Stegano -d infile\n\tjava BMP_LSB_Stegano -c infile outfile");
	}

}
